//+------------------------------------------------------------------+
//|                                              Hull moving average |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

//
//
//
//
//

extern int HMAPeriod  = 20;
extern int HMAPrice   = PRICE_CLOSE;
extern int HMAMethod  = MODE_LWMA;

//
//
//
//
//

double buffer1[];
double buffer2[];
int    HalfPeriod;
int    HullPeriod;

//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   HMAPeriod  = MathMax(2,HMAPeriod);
   HalfPeriod = MathFloor(HMAPeriod/2);
   HullPeriod = MathFloor(MathSqrt(HMAPeriod));
   
      SetIndexBuffer(0,buffer1);
      SetIndexBuffer(1,buffer2);

   IndicatorShortName("HMA "+HMAPeriod+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) buffer2[i] = iMA(NULL,0,HalfPeriod,0,HMAMethod,HMAPrice,i)*2-
                                        iMA(NULL,0,HMAPeriod ,0,HMAMethod,HMAPrice,i);
   for(i=limit; i>=0; i--) buffer1[i] = iMAOnArray(buffer2,0,HullPeriod,0,HMAMethod,i);
   return(0);
}